<template>
  <div class="a-select" v-click-outside="hideOptions">
    <div class="a-select-value" @click="toggleSelect">
      <p>
        {{ valueTitle }}
      </p>
    </div>
    <transition name="fade">
      <div v-if="showOption" class="a-select-list">
        <div class="a-select-search">
          <input
            type="text"
            v-model="keyword"
            :placeholder="searchPlaceholder"
          />
        </div>
        <div
          v-for="(option, key) of optionsFiltered"
          :class="[
            option.value === modelValue ? 'selected' : '',
            'a-select-option'
          ]"
          :key="'option-' + key"
          @click="chooseOption(option)"
        >
          {{ option.title }}
        </div>
      </div>
    </transition>
  </div>
</template>

<script setup>
import { defineProps, defineEmits, ref, computed, defineExpose } from 'vue';

const props = defineProps({
  modelValue: {
    type: null,
    required: true
  },
  options: {
    type: Array,
    required: true,
    description: 'Array object options for select [ { value: ??, title: ?? } ]'
  },
  placeholder: {
    type: String,
    default: 'Choose a option',
    description: 'Recommend for user'
  },
  search: {
    type: Boolean,
    default: false,
    required: false,
    description: 'Use search option by title'
  },
  searchPlaceholder: {
    type: String,
    default: 'Input your keyword',
    required: false,
    description: 'Placeholder for input search'
  }
});

const keyword = ref('');
const showOption = ref(false);

const optionsFiltered = computed(() => {
  if (!props.search) {
    return props.options;
  }

  return props.options.filter((item) =>
    item.title.toLowerCase().includes(keyword.value.toLowerCase())
  );
});

const valueTitle = computed(() => {
  const optionSelected = props.options.find(
    (item) => item.value === props.modelValue
  );
  return optionSelected?.title ?? props.placeholder;
});

const emit = defineEmits(['update:modelValue']);
const chooseOption = (option) => {
  emit('update:modelValue', option.value);
};

const toggleSelect = () => {
  showOption.value = !showOption.value;
};

const hideOptions = () => {
  showOption.value = false;
};

defineExpose({ hideOptions });
</script>

<style lang="scss" scoped>
.a-select {
  width: 400px;
  height: 40px;
  position: relative;
  border: 1px solid #cecece;
  border-radius: 3px;
  &-value {
    height: 100%;
    line-height: 40px;
    padding: 0 10px;
    p {
      text-overflow: ellipsis;
      overflow: hidden;
    }
  }

  &-list {
    position: absolute;
    z-index: 2;
    top: 100%;
    left: 0;
    width: 100%;
    height: auto;
    max-height: 300px;
    overflow: auto;
    box-shadow: 0 10px 10px 2px rgba($color: #333, $alpha: 0.3);
  }

  &-search {
    padding: 5px;
    height: 40px;
    input {
      width: 100%;
      height: 100%;
      border-radius: 3px;
      padding: 0 10px;
      border: 1px solid #cecece;
      &:focus {
        outline: none;
        box-shadow: 0 0 5px 2px rgba($color: royalblue, $alpha: 0.3);
      }
    }
  }

  &-option {
    height: 40px;
    background: #e6e6e6;
    line-height: 40px;
    padding: 0 10px;
    cursor: pointer;
    &.selected {
      background: #fff;
      color: royalblue;
    }
  }
}

.fade {
  &-enter-active {
    transform: scaleY(1);
  }

  &-leave-active {
    transform: scaleY(0);
  }
}
</style>
